/***************************************************************************
                          convert_date.cpp  -  description
                             -------------------
    begin                : Fri Aug 2 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include <string>
#include <cmath>
#include <cstdlib>
#include <ctime>

#include "askosio/string_convert.h"
#include "askosio/errorcheck.h"
#include "askosio/log.h"


using namespace std;


const string time_to_date(const double& t) {
  LOG(log);
  struct tm* tm_time;
  time_t tt=time_t(floor(t));
  tm_time = localtime(&tt);
  if ( tm_time==0 ) {
    log.internal_error() << "Got null pointer from localtime()." << endl;
    return "";
  }
  char buf[100];
  if ( strftime(buf,100,"%Y-%m-%d %H:%M:%S",tm_time)==0 ) {
    log.internal_error() << "'strftime' failed." << endl;
    return "";
  }
  string r(buf);
  return r;
}


const string time_to_timestamp(const double& t) {
  LOG(log);
  struct tm* tm_time;
  time_t tt=time_t(floor(t));
  tm_time = localtime(&tt);
  if ( tm_time==0 ) {
    log.internal_error() << "Got null pointer from localtime()." << endl;
    return "";
  }
  char buf[100];
  if ( strftime(buf,100,"%Y-%m-%d_%H-%M-%S",tm_time)==0 ) {
    log.internal_error() << "'strftime' failed." << endl;
    return "";
  }
  string r(buf);
  return r;
}


double time_to_daytime(const double& t) {
  LOG(log);
  // So geht es nicht, wg. Sommer- und Winterzeit.
  // double days = floor(t/(3600*24));
  // return t-days*(3600*24);
  struct tm* tm_time;
  time_t tt=time_t(floor(t));
  tm_time = localtime(&tt);
  if ( tm_time==0 ) {
    log.internal_error() << "Got null pointer from localtime()." << endl;
    return 0;
  }
  return tm_time->tm_hour*3600+tm_time->tm_min*60+tm_time->tm_sec+(t-floor(t));
}
