/***************************************************************************
                          timespec.cpp  -  description
                             -------------------
    begin                : Wed Apr 24 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/


#include <cmath>

#include "timespec.h"




timespec null_timespec={0,0};


double substract_timespec(const timespec& tv_stop, const timespec& tv_start) {
  return double(tv_stop.tv_sec)-double(tv_start.tv_sec)+
    (double(tv_stop.tv_nsec)-double(tv_start.tv_nsec))/double(1000000000);
}


void add_to_timespec(const double t, timespec& tv) {
  time_t sec=int(floor(t));
  long nsec=long(rint((t-sec)*1000000000));
  tv.tv_sec+=sec;
  tv.tv_nsec+=nsec;
  if (tv.tv_nsec>=1000000000) {
    tv.tv_sec++;
    tv.tv_nsec-=1000000000;
  }
}


void double_to_timespec(const double t, timespec& tv) {
#ifdef DEBUG_ASKOSDATES
  if (t<0) {
    FATAL_ERROR;
  }
#endif
  tv.tv_sec=time_t(floor(t));
  tv.tv_nsec=long(rint((t-tv.tv_sec)*1000000000));
}
