/***************************************************************************
                          timeval.cpp  -  description
                             -------------------
    begin                : Thu Apr 25 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include <cmath>

#include "timeval.h"




timeval null_timeval={0,0};


double substract_timeval(const timeval& tv_stop, const timeval& tv_start) {
  return double(tv_stop.tv_sec)-double(tv_start.tv_sec)+
    (double(tv_stop.tv_usec)-double(tv_start.tv_usec))/double(1000000);
}


void add_to_timeval(const double t, timeval& tv) {
  int sec=int(floor(t));
  unsigned usec=unsigned(rint((t-sec)*1000000));
  tv.tv_sec+=sec;
  tv.tv_usec+=usec;
  if (tv.tv_usec>1000000) {
    tv.tv_sec++;
    tv.tv_usec-=1000000;
  }
}


void double_to_timeval(const double t, timeval& tv) {
#ifdef DEBUG_ASKOSDATES
  if (t<0) {
    FATAL_ERROR;
  }
#endif
  tv.tv_sec=unsigned(floor(t));
  tv.tv_usec=unsigned(rint((t-tv.tv_sec)*1000000));
}
