/***************************************************************************
                          casc_map.h  -  description
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CASC_MAP_H
#define CASC_MAP_H


#include <map>
#include <string>


using namespace std;


template<class Element>
class Casc_Map {

private:

  mutable map<string,Element> elements;

public:

  Casc_Map() : elements() {
  }

  bool has(const string& name) const {
    return ( elements.find(name)!=elements.end() );
  }

  const Element& get(const string& name) const {
    return elements[name];
  }

  void add(const string& name, const Element& element) {
    elements[name]=element;
  }

};




#endif // CASC_MAP_H
