/***************************************************************************
                          infile.cpp  -  description
                             -------------------
    begin                : Thu Sep 19 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include "log.h"
#include "infile.h"




void Infile::error(const string& message) {
  Log o(&logdevice,"Infile","error");
  o.error() << message << endl;
  o.error_exit();
}


Infile::Infile() :
  ifstream(),
  logdevice(Log::get_default_logdevice()) {
}


Infile::Infile(Logdevice* logdevice_ptr) :
  ifstream(),
  logdevice(*logdevice_ptr) {
}


Infile::Infile(Logdevice* logdevice_ptr, const string& filename) :
  ifstream(),
  logdevice(*logdevice_ptr) {
  open(filename);
}


bool Infile::open(const string& filename) {
  ifstream::open(filename.c_str());
  if ( !(*this) ) {
    error("Opening file '"+filename+"' for reading failed.");
    return false;
  }
  return true;
}
