/***************************************************************************
                          logdevice.cpp  -  description
                             -------------------
    begin                : Tue Apr 9 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include <fstream>

#include "logdevice.h"


Logdevice::Logdevice() : 
  depth(0), 
  log_time(false),
  // out(clog.rdbuf()), Bei Borland C++ instabil?
  logstreambuf(clog.rdbuf()),
  out(&logstreambuf),
  debug_classnames() {
}


/*
bool Logdevice::open(const string& filename) {
  ofstream out_file(filename.c_str());
  if ( !out_file ) {
    return false;
  }
  out.rdbuf(out_file.rdbuf());
  // fixme: Geht das!? out_file verlaesst den Gueltigkeitsbereich!
  return true;
}
*/


void Logdevice::connect_to_stream(ostream& outputstream) {
  logstreambuf.connect_to_stream(outputstream);
}


void Logdevice::add_stream(ostream& outputstream) {
  logstreambuf.add_stream(outputstream);
}


void Logdevice::add_stream(Pointer<ostream> ostream_ptr) {
  logstreambuf.add_stream(ostream_ptr);
}


bool Logdevice::debug(const string& classname) const {
  // Borland C++ braucht Typkonvertierung
  return set<string>::const_iterator(debug_classnames.find(classname))!=debug_classnames.end();
  // return debug_classnames.find(classname)!=debug_classnames.end();
}


void Logdevice::debug_on(const string& classname) {
  debug_classnames.insert(classname);
}


/*
streambuf* Logdevice::get_streambuf(const string& classname) {
  return out.rdbuf();
}

streambuf* Logdevice::get_debugstreambuf(const string& classname) {
  if ( debug(classname) ) {
    return out.rdbuf();
  }
  return &nullstreambuf;
}
*/


ostream& Logdevice::get_ostream(const string& classname) {
  return out;
}


bool Logdevice::get_log_time() const {
  return log_time;
}


void Logdevice::set_log_time(const bool log_time_ini) {
  log_time=log_time_ini;
}
