/***************************************************************************
                          multiple_streambuf.cpp  -  description
                             -------------------
    begin                : Mon Mar 15 2004
    author               : Moritz Franosch
    copyright            : (C) 2004 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include "multiple_streambuf.h"


using namespace std;


Multiple_Streambuf::Multiple_Streambuf(streambuf* streambuf_ptr_ini) : 
  streambufs(),
  ostream_ptrs() {
  streambufs.push_back(streambuf_ptr_ini);
}


Multiple_Streambuf::~Multiple_Streambuf(){
}


void Multiple_Streambuf::connect_to_stream(ostream& outputstream) {
  streambufs.clear();
  add_stream(outputstream);
}


void Multiple_Streambuf::add_stream(ostream& outputstream) {
  streambufs.push_back(outputstream.rdbuf());
}


void Multiple_Streambuf::add_stream(Pointer<ostream> ostream_ptr) {
  ostream_ptrs.push_back(ostream_ptr);
  add_stream(*ostream_ptr);
}


int Multiple_Streambuf::overflow(int_type c) {
  if ( c!=EOF ) {
    bool iseof=false;
    for ( list<streambuf*>::iterator i=streambufs.begin(); i!=streambufs.end(); ++i) {
      if  ( (**i).sputc(c)==EOF ) {
	iseof=true;
      }
      if ( c=='\n' ) {
	(**i).pubsync();
      }
    }
    if (iseof) {
      return EOF;
    }
  }
  return c;
}
