/***************************************************************************
                          multiple_streambuf.h  -  description
                             -------------------
    begin                : Mon Mar 15 2004
    author               : Moritz Franosch
    copyright            : (C) 2004 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#ifndef MULTIPLE_STREAMBUF_H
#define MULTIPLE_STREAMBUF_H

#include <streambuf>
#include <iostream>
#include <list>

#include "askosdata/pointer.h"


/** A streambuf that writes into multiple streambufs simultaneously.
 */
class Multiple_Streambuf : public std::streambuf {

private:

  std::list<std::streambuf*> streambufs; // streambufs where to write

  std::list< Pointer<std::ostream> > ostream_ptrs; // save the ostreams

public: 

  /* Initializes with the streambuf streambuf_ini.
   */
  Multiple_Streambuf(std::streambuf* streambuf_ptr_ini);

  /** Virtual destructor.
   */
  virtual ~Multiple_Streambuf();

  /*The logdevice logs to the stream outputstream.
   */
  void connect_to_stream(std::ostream& outputstream);

  /* Adds the streambuf of the outputstream to the log devices.
   */
  void add_stream(std::ostream& outputstream);

  /* Adds the streambuf of the outputstream to the log devices.
   */
  void add_stream(Pointer<std::ostream> ostream_ptr);

protected:
  
  virtual int_type overflow(int_type c);

};


#endif // MULTIPLE_STREAMBUF_H
