/***************************************************************************
                          outfile.cpp  -  description
                             -------------------
    begin                : Thu Apr 25 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include "log.h"
#include "outfile.h"




void Outfile::error(const string& message) {
  Log o(&logdevice,"Outfile","error");
  o.error() << message << endl;
  o.error_exit();
}


Outfile::Outfile() :
  ofstream(),
  logdevice(Log::get_default_logdevice()) {
}


Outfile::Outfile(Logdevice* logdevice_ptr) : 
  ofstream(),
  logdevice(*logdevice_ptr) {
}


Outfile::Outfile(Logdevice* logdevice_ptr, const string& filename) :
  ofstream(),
  logdevice(*logdevice_ptr) {
  open(filename);
}


bool Outfile::open(const string& filename) {
  ofstream::open(filename.c_str());
  if ( !(*this) ) {
    error("Opening file '"+filename+"' for writing failed.");
    return false;
  }
  return true;
}
