/***************************************************************************
                          string_convert.h  -  description
                             -------------------
    begin                : Wed Apr 24 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#ifndef STRING_CONVERT_H
#define STRING_CONVERT_H

#ifdef __GNUC__
  // Borland C++ hat diesen Header nicht.
  #include "stdint.h"
#endif

#include <string>
#include <sstream>
#include <iostream>
#include <vector>


using namespace std;


namespace string_convert {

  template<class T>
  string to_string(const T& t) {
    /*
    char buf[1000];
    ostrstream s(buf,1000);
    s << t;
    s << ends;
    return s;
    */
    ostringstream s;
    s << t;
    return s.str();
  }

  const string int_to_zero_padded_string(const int i, const unsigned n);

  bool is_int(const string& s);

  int string_to_int(const string& s);

#ifdef __GNUC__
  int64_t string_to_int64(const string& s);
#else
  __int64 string_to_int64(const string& s);
#endif

  bool string_to_double(const string& s, double& r);

  const string tolower(const string& s);

  const string basename(const string& s);

  const string dirname(const string& s);

  const string without_whitespace(const string& s);

  const string without_leading_trailing_whitespace(const string& s);

  const string substitute(const string& substituent, const string& substitution, 
			  const string& s);

}


/** Wandelt t (in Sekunden) in '[Tage d] h:min s' um.
 */
const std::string seconds_to_daytime(const double& t);


template<class T>
ostream& 
operator<<(ostream& s, const vector<T>& v) {
  s << "(";
  for(typename vector<T>::const_iterator i=v.begin(); i!=v.end(); ++i) {
    if ( i!=v.begin() ) {
      s << ",";
    }
    s << *i;
  }
  s << ")";
  return s;
}




#endif // STRING_CONVERT_H
