/***************************************************************************
                          askosparam.h  -  description
                             -------------------
    begin                : Tue Apr 9 2002
    author               : Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#ifndef ASKOSPARAM_H
#define ASKOSPARAM_H

#include <map>

#include "askosdata/tree.h"
#include "askosio/logdevice.h"
#include "askosparam_callback.h"
#include "type.h"


class Askosparam {

public:

  Askosparam(Askosparam_Callback* callback_ptr, Logdevice* logdevice_ptr);

  Askosparam(Askosparam_Callback* callback_ptr, 
	     Logdevice* logdevice_ptr,
	     const string& directory);

  Askosparam(Askosparam_Callback* callback_ptr_ini,
	     Logdevice* logdevice_ptr_ini,
	     int argc,
	     char* argv[]);

  bool parse(const string& filename);

  bool parse(istream& istream);
  
private:

  Askosparam(const Askosparam&);

  Askosparam& operator=(const Askosparam&);

  bool parse_formatfile(const string& filename);

  Askosparam_Callback* callback_ptr;
  Logdevice* logdevice_ptr;
  typedef Tree<Type> Tree_t;

  map<string,Tree_t>* types_ptr;
  map<string,Tree_t>& types;
  // Workaround fuer Borland C++:
  // Destruktoraufruf map<string,Tree_t>::operator~() fuehrt zu Crash.
  // Deshalb wird 'delete types_ptr' nie aufgerufen.

  string filename;
  string directory; // Verzeichnis, in dem das Binary aufgerufen wurde.

};


#endif // ASKOSPARAM_H
