/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Th Nov 28 10:45:00 CET 2002
    author               : Christof Schatz, Moritz Franosch
    copyright            : (C) 2002 by ASKOS http://www.ASKOS.de
    email                : info@askos.de
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <string>
#include <cstdlib>

#include "tests/testsimilar.h"
#include "tests/testdate.h"
#include "tests/testpointer.h"
#include "tests/testmath.h"
#include "tests/testlog.h"
#include "tests/teststring.h"


using namespace std;




int main(int argc, char *argv[]) {
#ifdef __BORLANDC__
  #define VERSION "0.1b"
#endif

  cerr << "Libaskos Test-Programm Version " << VERSION << "." << endl;

  if (argc<=1) {
    cerr << "Syntax: libaskos TEST [Eingabedatei1] [Eingabedatei2] ..." << endl;
    return EXIT_FAILURE;
  }

  string name=argv[1];

  if (name=="failure") {
    cerr << "The failure test fails." << endl;
    return EXIT_FAILURE;
  } else if (name=="success") {
    cerr << "The success test succeeds." << endl;
    return EXIT_SUCCESS;
  } else if (name=="similar") {
    TestSimilar test;
    return test();
  } else if (name=="date") {
    TestDate test;
    return test();
  } else if (name=="pointer") {
    TestPointer test;
    return test();
  } else if (name=="math") {
    TestMath test;
    return test();
  } else if (name=="log") {
    TestLog test;
    return test();
  } else if (name=="string") {
    TestString test;
    return test();
  }

  cerr << "No such test '" << name << "'." << endl;

  return EXIT_FAILURE;
}
