/***************************************************************************
                          testpointer.cpp  -  description
                             -------------------
    begin                : Tue Jan 7 2003
    author               : Moritz Franosch
    copyright            : (C) 2003 by ASKOS http://www.ASKOS.de
    email                : mail@Franosch.org
 ***************************************************************************/

#include "askosdata/pointer.h"

#include "testpointer.h"

using namespace std;


class C {

private:

  bool* deleted_ptr;

public:

  C(bool* deleted_ptr_ini) : 
    deleted_ptr(deleted_ptr_ini) {
  }

  ~C() {
    *deleted_ptr=true;
  }

};


int TestPointer::operator()() {

  Pointer<int> p1(new int(3));
  
  if ( *p1 != 3 ) {
    return EXIT_FAILURE;
  }

  Pointer<int> p2(p1);
  if ( *p2 != 3 ) {
    return EXIT_FAILURE;
  }

  Pointer<int> p3;
  p3=p1;
  if ( *p3 != 3 ) {
    return EXIT_FAILURE;
  }

  *p2=4;
  if ( *p1 != 4 ) {
    return EXIT_FAILURE;
  }
  if ( *p2 != 4 ) {
    return EXIT_FAILURE;
  }
  if ( *p3 != 4 ) {
    return EXIT_FAILURE;
  }

  bool deleted=false;
  {
    Pointer<C> q1(new C(&deleted));
    if ( q1.use_count()!=1 ) {
      return EXIT_FAILURE;
    }
    {
      Pointer<C> q2(q1);
      if ( q1.use_count()!=2 ) {
	return EXIT_FAILURE;
      }
      {
	Pointer<C> q3;
	q3=q2;
	if ( q1.use_count()!=3 ) {
	  return EXIT_FAILURE;
	}
	if (deleted) {
	  return EXIT_FAILURE;
	}
      }
      if ( q1.use_count()!=2 ) {
	return EXIT_FAILURE;
      }
      if (deleted) {
	return EXIT_FAILURE;
      }
    }
    if ( q1.use_count()!=1 ) {
      return EXIT_FAILURE;
    }
    if (deleted) {
      return EXIT_FAILURE;
    }
  }
  if (!deleted) {
    return EXIT_FAILURE;
  }
  
  return EXIT_SUCCESS;
}
