/***************************************************************************
                          cusp_kernel.cpp  -  description
                             -------------------
    begin                : Sat Jan 11 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "askosmath/askosmath.h"

#include "errorcheck.h"
#include "cusp_kernel.h"


using namespace std;


Cusp_Kernel::Cusp_Kernel(const int d, const double h) : 
  Kernel(d,h,select(d,3.0/2.0,6.0/pi,15.0/(2*pi))) {
  REQUIRE(d>=1);
  REQUIRE(d<=3);
}


double Cusp_Kernel::w(const double x) const {
  REQUIRE(x>=0);
  return ( x>=1 ? 0 : sqr(1-x) );
}


double Cusp_Kernel::dw(const double x) const {
  REQUIRE(x>=0);
  return ( x>=1 ? 0 : 2*(x-1) );
}
