/***************************************************************************
                          geometry.h  -  description
                             -------------------
    begin                : Sat Mar 1 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GEOMETRY_H
#define GEOMETRY_H


#include "particle.h"


/** Base class for all geometric objects.
 *
 *  @author Moritz Franosch
 */
class Geometry {

public: 

  /** True if position p is inside the object.
   */
  virtual bool operator()(const Particle::vector_t& p) const =0;

  /** Writes the object as XML into o.
   */
  virtual void to_xml(std::ostream& o)=0;

  /** Virtual destructor.
   */
  virtual ~Geometry();

};


#endif // GEOMETRY_H
