/***************************************************************************
                          ipower.h  -  description
                             -------------------
    begin                : Sun Feb 16 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IPOWER_H
#define IPOWER_H


inline double ipow(double x, int n) {
  if (n<0) {
    x=1/x;
    n=-n;
  }
  double r=1;
  while (n>0) {
    if (n & 1>0) {
      r*=x;
    }
    n >>= 1;
    x*=x;
  }
  return r;
}


template<int n> double pow(double x) {
  return (  n>=0 ? ( pow<n/2>(x*x) * (n % 2>0 ? x : 1) ) : pow<-n>(1/x)  );
}


template<> inline double pow<0>(double) {
  return 1;
}


#endif // IPOWER_H
