/***************************************************************************
                          lucy_kernel.cpp  -  description
                             -------------------
    begin                : Sun Mar 2 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ipower.h"
#include "lucy_kernel.h"


Lucy_Kernel::Lucy_Kernel(const int d, const double h) :
  Kernel(d,h,select(d,5.0/4.0,5.0/pi,105.0/(16*pi))) {
  REQUIRE(d>=1);
  REQUIRE(d<=3);
}


double Lucy_Kernel::w(const double x) const {
  return ( x>=1 ? 0 : (1+3*x)*pow<3>(1-x) );
}


double Lucy_Kernel::dw(const double x) const {
  return ( x>=1 ? 0 : -12*x*pow<2>(1-x) );
}
