/***************************************************************************
                          lucy_kernel.h  -  description
                             -------------------
    begin                : Sun Mar 2 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LUCY_KERNEL_H
#define LUCY_KERNEL_H

#include "kernel.h"


/** Implements the kernel W(r) = alpha_d * (1+3r)(1-r)^3 for r<1, 0
 *  else introduced by Lucy.
 *
 *  @author Moritz Franosch
 */
class Lucy_Kernel : public Kernel {

public: 

  /** Constructor, see class Kernel.
   */
  Lucy_Kernel(const int d, const double h);

  /** Returns w(x)=(1+3x)(1-x)^3 for x<1, 0 else.
   */
  virtual double w(const double x) const;

  /** Returns dw(x)/dx.
   */
  virtual double dw(const double x) const;

};


#endif // LUCY_KERNEL_H
