/***************************************************************************
                          poly5_kernel.cpp  -  description
                             -------------------
    begin                : Mon Jan 20 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ipower.h"
#include "poly5_kernel.h"


Poly5_Kernel::Poly5_Kernel(const int d, const double h) :
  Kernel(d,h,select(d,693.0/512.0,6.0/pi,9009.0/(1024*pi))) {
  REQUIRE(d>=1);
  REQUIRE(d<=3);
}


double Poly5_Kernel::w(const double x) const {
  REQUIRE(x>=0);
  //  return ( x>=1 ? 0 : pow((1-sqr(x)),5) );
  return ( x>=1 ? 0 : pow<5>((1-sqr(x))) );
}


double Poly5_Kernel::dw(const double x) const {
  REQUIRE(x>=0);
  //  return ( x>=1 ? 0 : -10*x*pow((1-sqr(x)),4) );
  return ( x>=1 ? 0 : -10*x*pow<4>((1-sqr(x))) );
}
