/***************************************************************************
                          pyramid.h  -  description
                             -------------------
    begin                : Sat Mar 15 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PYRAMID_H
#define PYRAMID_H

#include <list>

#include "geometry.h"
#include "particle.h"


/** Pyramid.
 *
 *  @author Moritz Franosch
 */
class Pyramid : public Geometry {

private:

  Particle::vector_t top;
  std::list<Particle::vector_t> polygon;

public: 

  /** Constructs a pyramid with top and a base surface with edges c1,
   *  c2, c3 and c4.
   */
  Pyramid(const Particle::vector_t& top,
	  const Particle::vector_t& c1,
	  const Particle::vector_t& c2,
	  const Particle::vector_t& c3,
	  const Particle::vector_t& c4);

  virtual bool operator()(const Particle::vector_t& p) const;

  /** Writes the pyramid as XML into o.
   */
  virtual void to_xml(std::ostream& o);

};


#endif // PYRAMID_H
