/***************************************************************************
                          rax_handler.cpp  -  description
                             -------------------
    begin                : Sat Feb 1 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "askosio/string_convert.h"

#include "errorcheck.h"

#include "rax_handler.h"
#include "rax_parser.h"


using namespace std;


RAX_Handler::RAX_Handler() {
}


void RAX_Handler::start(RAX_Parser& parser, 
			const std::string& name, AttributeList& attributes) {
  parser.start_element(name,attributes);
}


void RAX_Handler::end(RAX_Parser& parser, const std::string& name) {
  parser.end_element(name);
}


void RAX_Handler::text(RAX_Parser& parser, 
		       const std::string& name, const string& t) {
  parser.text(name,t);
}


RAX_Handler::~RAX_Handler() {
}


double RAX_Handler::double_value(const std::string& s) const {
  double r=0;
  bool ok=string_convert::string_to_double(s,r);
  I(ok); // fixme
  return r;
}


int RAX_Handler::int_value(const std::string& s) const {
  return string_convert::string_to_int(s);
}
