/***************************************************************************
                          rax_handler.h  -  description
                             -------------------
    begin                : Sat Feb 1 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RAX_HANDLER_H
#define RAX_HANDLER_H


#include <string>

#include "xercesc/sax/HandlerBase.hpp"




class RAX_Parser;


/** Handler for class RAX_Parser.
 *
 *  @author Moritz Franosch
 */
class RAX_Handler {

public: 

  /** Constructor.
   */
  RAX_Handler();

  /** Called when a tag starts.
   */
  virtual void start(RAX_Parser& parser, 
		     const std::string& name, AttributeList& attributes);

  /** Called when a tag ends.
   */
  virtual void end(RAX_Parser& parser, const std::string& name);

  /** Called before a tag starts or ends when character data is
   *  available.
   */
  virtual void text(RAX_Parser& parser, 
		    const std::string& name, const std::string& t);

  /** Virtual destructor.
   */
  virtual ~RAX_Handler();

  /** Converts the string s to a double.
   *
   *  fixme: error handling
   */
  virtual double double_value(const std::string& s) const;

  /** Converts the string s to an int.
   *
   *  fixme: error handling
   */
  virtual int int_value(const std::string& s) const;

};


#endif // RAX_HANDLER_H
