/***************************************************************************
                          smooth_triangle.cpp  -  description
                             -------------------
    begin                : Sun Nov 16 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "smooth_triangle.h"


using namespace std;


Smooth_Triangle::Smooth_Triangle(const Particle::vector_t& p1, 
				 const Particle::vector_t& p2,
				 const Particle::vector_t& p3,
				 const Particle::vector_t& n1_ini, 
				 const Particle::vector_t& n2_ini,
				 const Particle::vector_t& n3_ini) :
  Triangle(p1,p2,p3),
  n1(n1_ini), n2(n2_ini), n3(n3_ini) {
}


const Particle::vector_t& Smooth_Triangle::get_normal1() const {
  return n1;
}


const Particle::vector_t& Smooth_Triangle::get_normal2() const {
  return n2;
}


const Particle::vector_t& Smooth_Triangle::get_normal3() const {
  return n3;
}


void Smooth_Triangle::to_xml(ostream& o) {
  //  Triangle::to_xml(o);
  o << "<smooth_triangle>" << endl;
  o << "  <corner1> " 
    << Particle::list_vector(get_corner1()) << " </corner1>" << endl;
  o << "  <corner2> " 
    << Particle::list_vector(get_corner2()) << " </corner2>" << endl;
  o << "  <corner3> " 
    << Particle::list_vector(get_corner3()) << " </corner3>" << endl;
  o << "  <normal1> " 
    << Particle::list_vector(get_normal1()) << " </normal1>" << endl;
  o << "  <normal2> " 
    << Particle::list_vector(get_normal2()) << " </normal2>" << endl;
  o << "  <normal3> " 
    << Particle::list_vector(get_normal3()) << " </normal3>" << endl;
  o << "</smooth_triangle>" << endl;
}
