/***************************************************************************
                          sphere.cpp  -  description
                             -------------------
    begin                : Sun Feb 2 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sphere.h"


using namespace std;


Sphere::Sphere(const Particle::vector_t& p, const double r) :
  position(p), 
  radius(r) {
}


void Sphere::set_radius(const double r) {
  radius=r;
}


const Particle::vector_t& Sphere::get_position() const {
  return position;
}


double Sphere::get_radius() const {
  return radius;
}


bool Sphere::operator()(const Particle::vector_t& p) const {
  return sqr_euclidian_distance(position,p)<sqr(radius);
}


void Sphere::to_xml(std::ostream& o) {
  o << "<sphere>" << endl;
  o << "  <position> " 
    << Particle::list_vector(get_position()) << " </position>" << endl;
  o << "  <radius> " << get_radius() << " </radius>" << endl;
  o << "</sphere>" << endl;
}
