/***************************************************************************
                          sphere.h  -  description
                             -------------------
    begin                : Sun Feb 2 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPHERE_H
#define SPHERE_H


#include "geometry.h"
#include "particle.h"


/** A sphere.
 *
 *  @author Moritz Franosch
 */
class Sphere : public Geometry {

private:

  Particle::vector_t position; // the coordinates and ...
  double radius; // ... the radius of the sphere

public: 
  
  /** Constructs a sphere with p and radius r.
   */
  Sphere(const Particle::vector_t& p, const double r);

  /** Sets the radius of the spere.
   */
  void set_radius(const double r);

  /** Returns the position of the sphere.
   */
  const Particle::vector_t& get_position() const;

  /** Returns the radius of the sphere.
   */
  double get_radius() const;

  virtual bool operator()(const Particle::vector_t& p) const;

  /** Writes the sphere as XML into o.
   */
  virtual void to_xml(std::ostream& o);

};


#endif // SPHERE_H
