/***************************************************************************
                          testintegration.cpp  -  description
                             -------------------
    begin                : Sat Feb 22 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>

#include "blitz/tinyvec-et.h"
#include "errorcheck.h"

#include "sph.h"
#include "testintegration.h"


using namespace std;


int TestIntegration::operator()() {

  double stop_time=10;

  double dt=0.01;

  SPH sph(2,1,1,1,0.1,10,dt);

  // insert particle
  Particle::vector_t p(0);
  p[0]=0.5;
  p[1]=0.75;
  sph.insert_particle(p);
  sph.start();

  // use gravity for spring strength
  Particle::vector_t g(0);

  // generate XML output
  cout << "<output>" << endl;
  cout << "<simulation>" << endl;
  while ( sph.get_time() < stop_time ) {
    sph.reset();
    g[1]=10/0.25*(0.5-sph.get_particle().get_position()(1));
    sph.set_gravity(g);
    sph.update();
    cout << sph; // output sph as XML
  }
  cout << "</simulation>" << endl;
  cout << "</output>" << endl;

  return EXIT_SUCCESS;
}
