/***************************************************************************
                          testlimits.cpp  -  description
                             -------------------
    begin                : Sat Mar 1 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mylimits.h"

#include <iostream>

#include "testlimits.h"


using namespace std;


int TestLimits::operator()() {

  double inf_d = numeric_limits<double>::infinity();
  double nan_d = numeric_limits<double>::quiet_NaN();
  float inf_f = numeric_limits<float>::infinity();
  float nan_f = numeric_limits<float>::quiet_NaN();

  if ( !isinf(inf_d) ) {
    return EXIT_FAILURE;
  }

  if ( !isnan(nan_d) ) {
    return EXIT_FAILURE;
  }

  if ( !isinf(inf_f) ) {
    return EXIT_FAILURE;
  }

  if ( !isnan(nan_f) ) {
    return EXIT_FAILURE;
  }

  return EXIT_SUCCESS;
}
