/***************************************************************************
                          triangle.cpp  -  description
                             -------------------
    begin                : Sun Mar 30 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "triangle.h"


using namespace std;


Triangle::Triangle(const Particle::vector_t& p1_ini, 
		   const Particle::vector_t& p2_ini,
		   const Particle::vector_t& p3_ini) :
  p1(p1_ini),
  p2(p2_ini),
  p3(p3_ini) {
}


bool Triangle::operator()(const Particle::vector_t&) const {
  return false;
}


const Particle::vector_t& Triangle::get_corner1() const {
  return p1;
}


const Particle::vector_t& Triangle::get_corner2() const {
  return p2;
}


const Particle::vector_t& Triangle::get_corner3() const {
  return p3;
}


void Triangle::to_xml(ostream& o) {
  o << "<triangle>" << endl;
  o << "  <corner1> " 
    << Particle::list_vector(get_corner1()) << " </corner1>" << endl;
  o << "  <corner2> " 
    << Particle::list_vector(get_corner2()) << " </corner2>" << endl;
  o << "  <corner3> " 
    << Particle::list_vector(get_corner3()) << " </corner3>" << endl;
  o << "</triangle>" << endl;
}
