/***************************************************************************
                          triangle.h  -  description
                             -------------------
    begin                : Sun Mar 30 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "geometry.h"


/** A triangle.
 *
 *  @author Moritz Franosch
 */
class Triangle : public Geometry {

private:

  Particle::vector_t p1, p2, p3; // corners of the triangle

public: 

  /** Constructs a triangle with corners p1, p2 and p3.
   */
  Triangle(const Particle::vector_t& p1, const Particle::vector_t& p2,
	   const Particle::vector_t& p3);

  /** Returns false.
   */
  virtual bool operator()(const Particle::vector_t& p) const;

  /** Returns the first corner.
   */
  const Particle::vector_t& get_corner1() const;

  /** Returns the second corner.
   */
  const Particle::vector_t& get_corner2() const;

  /** Returns the third corner.
   */
  const Particle::vector_t& get_corner3() const;

  /** Writes the triangle as XML into o.
   */
  virtual void to_xml(std::ostream& o);

};


#endif // TRIANGLE_H
