/***************************************************************************
                          voxel.h  -  description
                             -------------------
    begin                : Sun Mar 9 2003
    copyright            : (C) 2003 by Moritz Franosch
    email                : mail@Franosch.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VOXEL_H
#define VOXEL_H

#include "box.h"


/** Voxel.
 *
 *  @author Moritz Franosch
 */
class Voxel : public Box {

public: 

  /** Constructs a voxel with corners p1 and p2.
   */
  Voxel(const Particle::vector_t& p1, const Particle::vector_t& p2);

  /** Writes the voxel as XML into o.
   */
  virtual void to_xml(std::ostream& o);

};


#endif // VOXEL_H
