#include "colors.inc"


#declare Lightpower = White*300;


global_settings {
  assumed_gamma 1.0
}


camera {
  location <0.5,1.6,-3>
  look_at <0.5,0,2>
  angle 32
}


light_source { 
  <0.5,2.1,1>
  color Lightpower
  area_light <2,0,0>, <0,0,3>, 6, 1
  fade_power 2
  fade_distance 0.1
}


light_source { 
  <0.5,2.1,-1>
  color 0.5*Lightpower
  fade_power 2
  fade_distance 0.1
}


#declare Glass = texture {
  pigment { White filter 1 }
  finish {
    ambient 0.0
    diffuse 0.0
    reflection 0.1
    specular 1
    roughness 0.001
  }
}


#declare Glass_interior = interior {
  ior 1.5
  caustics 1
}


#declare Water = texture {
  pigment { rgb <0,0,1> filter 1 }
  finish {
    ambient 0.0
    diffuse 0.0
    reflection 0.2
    specular 1
    roughness 0.001
  }
}


#declare Water_interior = interior {
  ior 1.33
  caustics 1
  fade_power 1
  fade_distance 4
}


#declare Wall = finish {
  ambient 0
  diffuse 0.8
  brilliance 1.3
  specular 1
  roughness 0.001
  reflection 0.1
}


#declare Checker = pigment {
  checker 0.5*White, White
  scale 0.2
}


#declare Side = Glass


#declare Back = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


#declare Bottom = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


plane { y, 0.001
  texture { Bottom }
}


box {
  <0,0,0>, <-0.1,1,2>
  texture {
    Glass
  }
  interior {
    Glass_interior
  }
}


box {
  <1,0,0>, <1.1,1,2>
  texture {
    Glass
  }
  interior {
    Glass_interior
  }
}


box {
  <-0.1,0,2>, <1.1,1,2.1>
  texture {
    Back
  }
  interior {
    Glass_interior
  }
}


intersection {

  box {
    <0.001,0.002,0.2>, <0.999,1,1.999>
  }

  merge {

    #include "elements.pov"

  }

  texture {
    Water
  }
  interior {
    Water_interior
  }

}
