#include "colors.inc"


#declare Lightpower = White*300;


global_settings {
  assumed_gamma 1.0
}


camera {
  location <0.5,1.6,-3>
  look_at <0.5,0,2>
  angle 32
}


light_source { 
  <0.5,2.1,0.5>
  color Lightpower
  area_light <2,0,0>, <0,0,3>, 3, 1
  fade_power 2
  fade_distance 0.1
}


light_source { 
  <0.5,2.1,-1>
  color 0.5*Lightpower
  fade_power 2
  fade_distance 0.1
}


#declare Water = texture {
  pigment { rgb <0,0,1> }
}



#declare Wall = finish {
  ambient 0
  diffuse 0.8
}


#declare Checker = pigment {
  checker 0.5*White, White
  scale 0.2
}



#declare Back = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


#declare Bottom = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


#declare Glass = texture {
  pigment { White filter 1 }
  finish {
    ambient 0.0
    diffuse 0.0
    reflection 0.1
    specular 1
    roughness 0.001
  }
}


#declare Glass_interior = interior {
  ior 1.5
}


plane { y, 0.001
  texture { Bottom }
}


box {
  <-0.1,0,1>, <1.1,1,1.1>
  texture {
    Back
  }
}

#declare Red = texture {
  pigment { rgb <1,0,0> }
}
#declare Green = texture {
  pigment { rgb <0,1,0> }
}
#declare Blue = texture {
  pigment { rgb <0,0,1> }
}
#declare Yellow = texture {
  pigment { rgb <1,1,0> }
}
#declare Magenta = texture {
  pigment { rgb <1,0,1> }
}
#declare Cyan = texture {
  pigment { rgb <0,1,1> }
}

    #include "elements.pov"
