#include "colors.inc"

#declare IOR = 1.05;
#declare Distance = 20;

#declare Col1 = -15;
#declare Col2 =  35;
#declare Row1 =  25;
#declare Row2 =  -5;

camera {
  orthographic
  location <0, 0, -100>
  right 80 * 4/3 * x
  up    80 * y
  look_at <0, 0, 0>
}


plane { -z, -20
   pigment {
      color White
   }
   finish {
      ambient 1
      diffuse 0
   }
}

//
// Translucent sphere without attenuation
//

sphere { <Col1, Row1, 0>, 10
  pigment { color Red filter 1 } // rgbt<1, 0, 0, 0.9> }
  finish {
    ambient 0
    diffuse 0
  }
  interior {
    ior 1
//    fade_distance Distance
//    fade_power 0
  }
}

//
// Translucent sphere with linear attenuation
//

sphere { <Col2, Row1, 0>, 10
  pigment { color Red filter 1 } // rgbt<1, 0, 0, 0.9> }
  finish {
    ambient 0
    diffuse 0
  }
  interior {
    ior 1
    fade_distance Distance
    fade_power 1
  }
}



light_source { <10000, 10000, -10000> color White }

