#include "colors.inc"


#declare Lightpower = White*300;


global_settings {
  assumed_gamma 1.0
  max_trace_level 10

  photons {
    spacing 0.03
    autostop 0
    jitter 0
  }

}


camera {
  location <2,1.6,-2.5>
  look_at <0.2,0,1>
  angle 27
}


light_source { 
  <0.5,1.5,0.5>
  color 0.5*Lightpower
  fade_power 2
  fade_distance 0.1

  photons {
    refraction on
    reflection on
  }

}


#declare Glass = texture {
  pigment { White filter 1 }
  finish {
    ambient 0.0
    diffuse 0.0
    reflection 0.1
    specular 1
    roughness 0.001
  }
}


#declare Glass_interior = interior {
  ior 1.5
}


#declare Water = texture {
  pigment { rgb <0,0,1> filter 1 }
  finish {
    ambient 0.0
    diffuse 0.0
    reflection 0.2
    specular 1
    roughness 0.001
  }
}


#declare Water_interior = interior {
  ior 1.33
  fade_power 1
  fade_distance 4
}


#declare Wall = finish {
  ambient 0
  diffuse 0.8
  brilliance 1.3
  specular 1
  roughness 0.001
  reflection 0.1
}


#declare Checker = pigment {
  checker 0.5*White, White
  scale 0.2
}


#declare Side = Glass


#declare Back = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


#declare Bottom = texture {
  pigment { 
    Checker
  }
  finish {
    Wall
  }
}


plane { y, 0.001
  texture { Bottom }
}




sphere {
   <0.5,0.5,0.5> 0.2
  
  texture { Water }

  interior {
    Water_interior
  }

  photons {
    target
    reflection on
    refraction on
    collect off
  }  

}
